load("im_cookbook_111299_tenant_setup_extension/tenant/extension/common");

/**
 * Set the tenant attributes.
 * 
 * @param {Object} request The value set on the screen.
 * @param {String} point Extention point. ("create" or "edit") 
 * 				This is used when changing the processing at the time of register or update.
 * @param {Object} attributes The value set in the argument "attributes" is registered as a tenant attribute. 
 */
function setAttribute(request, point, attributes) {

    for(var key in attributes){
        if (key.indexOf(PREFIX_4_TENANT_ATTR_KEY) == 0){
            // Delete the old values
            delete attributes[key];
        }
    }

    for(var key in request){
        if (key.indexOf(PREFIX_4_TENANT_ATTR_KEY) == 0){
            // Set the tenant attributes
            attributes[key] = request[key];
        }
    }

}

/**
 * Sample for correlation validation.
 * 
 * In addition, Single item validation is validated with JsValidator.
 * (JsValidator : jssp/src/im_cookbook_111299_tenant_setup_extension/tenant/extension/validators/tenant_extension.js)
 * 
 * @param {Object} request The value set on the screen.
 * @param {String} point Extention point. ("create" or "edit") 
 * 
 * @return {Object} Result object.
 */
function validation(request, point) {
    var host, port;
    
    for(var key in request){
        if (key == PREFIX_4_TENANT_ATTR_KEY + "host"){
            host = request[key];
        }
        if (key == PREFIX_4_TENANT_ATTR_KEY + "port"){
            port = request[key];
        }
    }
    
    // Sample for correlation validation. 
    if (host == "localhost" && port != null && port <= 1024){
        return {
            error : true,
            errorMessage : "Enter numeric greater than 1024 for Port number, if you set \"localhost\" on the hostname value about Connection Info (cookbook_111299)."
        };
    }
    
    return {
        error : false
    };
}
